function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useRef, useState, createContext, useEffect, useMemo } from 'react';
import classnames from 'classnames';
import { Popover, Form } from 'rlj-design';
import moment from 'moment';
import ResizeObserver from 'rc-resize-observer';
import FilterBtn from "./FilterBtn";
import FilterContent from "./FilterContent";
import FilterResult from "./FilterResult";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter");
export var FilterContext = /*#__PURE__*/createContext(null);

var Filter = function Filter(props) {
  var overlayClassName = props.overlayClassName,
      trigger = props.trigger,
      btnText = props.btnText,
      btnRender = props.btnRender,
      filterTitle = props.filterTitle,
      filterSecondTitle = props.filterSecondTitle,
      filterNode = props.filterNode,
      filterLeftNode = props.filterLeftNode,
      showSelectedTag = props.showSelectedTag,
      realFilterOk = props.filterOk,
      setHeight = props.setHeight,
      addFields = props.addFields,
      items = props.items,
      searchFields = props.searchFields;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var getFieldsValue = form.getFieldsValue;

  var _useState = useState([]),
      _useState2 = _slicedToArray(_useState, 2),
      fields = _useState2[0],
      setFields = _useState2[1];

  var filterRef = useRef(null);

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      open = _useState4[0],
      setOpen = _useState4[1];

  var _useState5 = useState(new Map([])),
      _useState6 = _slicedToArray(_useState5, 1),
      itemsMap = _useState6[0];

  var _useState7 = useState(new Map([])),
      _useState8 = _slicedToArray(_useState7, 1),
      addressMap = _useState8[0];

  useEffect(function () {
    items === null || items === void 0 ? void 0 : items.forEach(function (_ref) {
      var fieldId = _ref.fieldId,
          fieldName = _ref.fieldName,
          fieldType = _ref.fieldType,
          multiSelect = _ref.multiSelect,
          type = _ref.type;
      itemsMap.set(fieldId, {
        fieldId: fieldId,
        fieldName: fieldName,
        fieldType: fieldType,
        multiSelect: multiSelect,
        type: type
      });
    });
  }, [items]);
  var hasData = useMemo(function () {
    var _fields$filter;

    return !!(fields !== null && fields !== void 0 && (_fields$filter = fields.filter(function (item) {
      var _item$value;

      return String((_item$value = item === null || item === void 0 ? void 0 : item.value) !== null && _item$value !== void 0 ? _item$value : []);
    })) !== null && _fields$filter !== void 0 && _fields$filter.length);
  }, [fields]);
  useEffect(function () {
    if (!(searchFields !== null && searchFields !== void 0 && searchFields.length)) return;
    setFields(searchFields);
  }, [searchFields]);

  var valueHandle = function valueHandle(fieldId, value, express, type) {
    var _ref2 = itemsMap.get(fieldId) || {
      fieldType: type || 'string'
    },
        fieldType = _ref2.fieldType;

    var showValue = {
      fieldId: fieldId,
      selections: [],
      value: ''
    };

    switch (fieldType) {
      case 'number':
      case 'string':
        showValue.value = value;

        if (express) {
          showValue.express = express;
        }

        break;

      case 'date':
        if (value) {
          var _value = _slicedToArray(value, 2),
              startDate = _value[0],
              endDate = _value[1];

          showValue.range = {
            from: moment(startDate).format('YYYY-MM-DD'),
            to: moment(endDate).format('YYYY-MM-DD')
          };
        }

        break;

      case 'emp':
      case 'org':
      case 'selection':
      case 'object':
        if (typeof value !== 'string') {
          showValue.selections = Array.isArray(value) ? value === null || value === void 0 ? void 0 : value.map(function (_ref3) {
            var value = _ref3.value;
            return value;
          }) : [value === null || value === void 0 ? void 0 : value.value];
        } else {
          showValue.selections = [value];
        }

        break;

      case 'address':
        showValue.selections = value === null || value === void 0 ? void 0 : value.map(function (item) {
          return item[(item === null || item === void 0 ? void 0 : item.length) - 1];
        }).map(function (item) {
          return typeof item === 'string' ? item : item.value;
        });
        break;

      default:
        break;
    }

    return showValue;
  };

  var resultHandle = function resultHandle() {
    var _getFieldsValue, _formFields$concat;

    var formFields = ((_getFieldsValue = getFieldsValue()) === null || _getFieldsValue === void 0 ? void 0 : _getFieldsValue.fields) || searchFields || [];
    return (formFields === null || formFields === void 0 ? void 0 : (_formFields$concat = formFields.concat(addFields)) === null || _formFields$concat === void 0 ? void 0 : _formFields$concat.filter(function (item) {
      var _item$value2;

      return String((_item$value2 = item === null || item === void 0 ? void 0 : item.value) !== null && _item$value2 !== void 0 ? _item$value2 : []);
    }).map(function (_ref4) {
      var fieldId = _ref4.fieldId,
          value = _ref4.value,
          express = _ref4.express,
          fieldType = _ref4.fieldType;
      return valueHandle(fieldId, value, express, fieldType);
    })) || [];
  };

  var filterOk = function filterOk() {
    var _getFieldsValue2, _getFieldsValue2$fiel, _getFieldsValue2$fiel2;

    var formValues = (_getFieldsValue2 = getFieldsValue()) === null || _getFieldsValue2 === void 0 ? void 0 : (_getFieldsValue2$fiel = _getFieldsValue2.fields) === null || _getFieldsValue2$fiel === void 0 ? void 0 : (_getFieldsValue2$fiel2 = _getFieldsValue2$fiel.filter(function (item) {
      return !!item;
    })) === null || _getFieldsValue2$fiel2 === void 0 ? void 0 : _getFieldsValue2$fiel2.map(function (item) {
      var _itemsMap$get;

      return _objectSpread(_objectSpread({}, item), {}, {
        value: (itemsMap === null || itemsMap === void 0 ? void 0 : (_itemsMap$get = itemsMap.get(item === null || item === void 0 ? void 0 : item.fieldId)) === null || _itemsMap$get === void 0 ? void 0 : _itemsMap$get.fieldType) === 'address' ? addressMap.get(item === null || item === void 0 ? void 0 : item.fieldId) : item === null || item === void 0 ? void 0 : item.value
      });
    });
    realFilterOk && realFilterOk(resultHandle(), searchFields ? searchFields : formValues);
  };

  useEffect(function () {
    if (!addFields && !searchFields) return;
    filterOk && filterOk();
  }, [addFields, searchFields]);
  return /*#__PURE__*/React.createElement(ResizeObserver, {
    onResize: function onResize(_ref5) {
      var height = _ref5.height;
      setHeight && setHeight(height);
    }
  }, /*#__PURE__*/React.createElement(FilterContext.Provider, {
    value: _objectSpread(_objectSpread({}, props), {}, {
      fields: fields,
      setFields: setFields,
      itemsMap: itemsMap,
      filterOk: filterOk,
      addressMap: addressMap,
      hasData: hasData
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    ref: filterRef
  }, filterLeftNode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filterLeftNode")
  }, filterLeftNode), /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "filter-content",
    autoComplete: "off"
  }, /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(FilterContent, {
      filterTitle: filterTitle,
      filterSecondTitle: filterSecondTitle
    }),
    placement: "bottomLeft",
    trigger: trigger,
    overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
    getPopupContainer: function getPopupContainer() {
      return filterRef.current;
    },
    open: open,
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    }
  }, btnRender ? btnRender : /*#__PURE__*/React.createElement(FilterBtn, {
    open: open,
    setOpen: setOpen
  }, btnText))), filterNode && /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-filterNode")
  }, filterNode)), showSelectedTag && /*#__PURE__*/React.createElement(FilterResult, {
    form: form
  })));
};

Filter.defaultProps = {
  trigger: 'click',
  btnText: '筛选',
  unit: '项',
  total: 0,
  showSelectedTag: true
};
export default Filter;