function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useContext } from 'react';
import moment from 'moment';
import { Tag, Typography, Button } from 'rlj-design';
import { FilterContext } from "./Filter";
import { PREFIX_CLS } from "../constants/dictionary";
import { deleteItem } from "./FilterValue";
import "./style/filterResult.less";
var prefixCls = "".concat(PREFIX_CLS, "-filter-result");

var FilterResult = function FilterResult(_ref) {
  var _fields$concat;

  var form = _ref.form;

  var _ref2 = useContext(FilterContext) || {},
      _ref2$fields = _ref2.fields,
      fields = _ref2$fields === void 0 ? [] : _ref2$fields,
      total = _ref2.total,
      unit = _ref2.unit,
      itemsMap = _ref2.itemsMap,
      addressMap = _ref2.addressMap,
      hasData = _ref2.hasData,
      setFields = _ref2.setFields,
      filterOk = _ref2.filterOk,
      _ref2$addFields = _ref2.addFields,
      addFields = _ref2$addFields === void 0 ? [] : _ref2$addFields,
      onReset = _ref2.onReset;

  var setFieldsValue = form.setFieldsValue,
      resetFields = form.resetFields;

  var valueHandle = function valueHandle(fieldId, value, type) {
    var _ref5, _ref5$map;

    var _ref3 = itemsMap.get(fieldId) || {
      fieldName: '',
      fieldType: type || 'string'
    },
        fieldName = _ref3.fieldName,
        fieldType = _ref3.fieldType;

    var showValue = value;

    switch (fieldType) {
      case 'number':
      case 'string':
        break;

      case 'date':
        if (value) {
          var _value = _slicedToArray(value, 2),
              startDate = _value[0],
              endDate = _value[1];

          showValue = "".concat(moment(startDate).format('YYYY-MM-DD'), "~").concat(moment(endDate).format('YYYY-MM-DD'));
        }

        break;

      case 'emp':
      case 'org':
      case 'selection':
      case 'object':
        if (typeof value !== 'string') {
          var _value$map;

          showValue = Array.isArray(value) ? value === null || value === void 0 ? void 0 : (_value$map = value.map(function (_ref4) {
            var label = _ref4.label;
            return label;
          })) === null || _value$map === void 0 ? void 0 : _value$map.join('、') : value === null || value === void 0 ? void 0 : value.label;
        } else {
          showValue = value;
        }

        break;

      case 'address':
        showValue = (_ref5 = addressMap !== null && addressMap !== void 0 && addressMap.size ? addressMap === null || addressMap === void 0 ? void 0 : addressMap.get(fieldId) : value) === null || _ref5 === void 0 ? void 0 : (_ref5$map = _ref5.map(function (item) {
          var _item;

          return (_item = item[(item === null || item === void 0 ? void 0 : item.length) - 1]) === null || _item === void 0 ? void 0 : _item.label;
        })) === null || _ref5$map === void 0 ? void 0 : _ref5$map.join('、');
        break;

      default:
        break;
    }

    return [fieldName, showValue];
  };

  var resetFilter = function resetFilter() {
    resetFields();
    setFieldsValue({
      fields: [undefined]
    });
    setFields([]);
    onReset && onReset();
    filterOk && filterOk();
  };

  return /*#__PURE__*/React.createElement(React.Fragment, null, // 这里的判断是至少有一条值的时候再出条件项展示
  (hasData || !!(addFields !== null && addFields !== void 0 && addFields.length)) && /*#__PURE__*/React.createElement("div", {
    className: prefixCls
  }, /*#__PURE__*/React.createElement("span", {
    className: "".concat(prefixCls, "-info")
  }, "\u5171\u7B5B\u9009\u51FA", /*#__PURE__*/React.createElement("span", null, total), unit), fields === null || fields === void 0 ? void 0 : (_fields$concat = fields.concat(addFields)) === null || _fields$concat === void 0 ? void 0 : _fields$concat.map(function (item, index) {
    var _ref6 = item || {},
        fieldId = _ref6.fieldId,
        express = _ref6.express,
        value = _ref6.value,
        onTagClose = _ref6.onTagClose,
        addFieldName = _ref6.fieldName,
        _ref6$closeable = _ref6.closeable,
        closeable = _ref6$closeable === void 0 ? true : _ref6$closeable,
        fieldType = _ref6.fieldType;

    var _valueHandle = valueHandle(fieldId, value, fieldType),
        _valueHandle2 = _slicedToArray(_valueHandle, 2),
        fieldName = _valueHandle2[0],
        showValue = _valueHandle2[1];

    var showName = fieldName || addFieldName || '';
    return String(showValue !== null && showValue !== void 0 ? showValue : []) && /*#__PURE__*/React.createElement("span", {
      key: fieldId,
      className: "".concat(prefixCls, "-conditions")
    }, /*#__PURE__*/React.createElement(Tag, {
      height: 20,
      type: "filter",
      closable: closeable,
      onClose: function onClose() {
        if (onTagClose) {
          return onTagClose();
        }

        if (deleteItem) {
          deleteItem(index);
        } else {
          setFields(fields.filter(function (_ref7) {
            var id = _ref7.fieldId;
            return id !== fieldId;
          }));
        }
      }
    }, /*#__PURE__*/React.createElement(Typography.LongText, {
      length: 16,
      text: "".concat(showName).concat(showName ? '：' : '').concat(express || '').concat(showValue),
      tooltip: "".concat(showName).concat(showName ? '：' : '').concat(express || '').concat(showValue)
    })));
  }), /*#__PURE__*/React.createElement(Button, {
    type: "link",
    noPadding: true,
    size: "small",
    onClick: resetFilter
  }, "\u91CD\u7F6E")));
};

export default FilterResult;