var _excluded = ["children"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import "./index.less";

/**
 * 高亮字符串
 * @param props
 * @returns
 */
import { PREFIX_CLS } from "../constants/dictionary";
var prefixCls = "".concat(PREFIX_CLS, "-highlight");

var HighLight = function HighLight(props) {
  var children = props.children,
      otherProps = _objectWithoutProperties(props, _excluded);

  var highLightText = otherProps.highLightText;
  if (!highLightText) return children;
  var index = children.indexOf(highLightText); // heightLight 为空字符会无限递归

  if (index === -1) {
    return children;
  } else {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children.slice(0, index), /*#__PURE__*/React.createElement("span", {
      className: "".concat(prefixCls, "-text")
    }, highLightText), /*#__PURE__*/React.createElement(HighLight, otherProps, children.slice(index + highLightText.length)));
  }
};

export default HighLight;