import React from 'react';
import type { SelectProps } from 'rlj-design';
import type { DefaultOptionType } from 'antd/lib/select';
import type { Service } from 'ahooks/lib/useRequest/src/types.d';
export interface OptionItemType extends DefaultOptionType {
    desc?: React.ReactNode;
}
export interface ProSelectProps extends Omit<SelectProps, 'mode'> {
    mode?: 'multiple';
    /** 选中 option，或 input 的 value 变化时，调用此函数 */
    onChange?: (value: any, options?: OptionItemType | OptionItemType[], item?: Map<string, OptionItemType>) => void;
    /** 文本框值变化时的回调 */
    onSearch?: (value: string, getEmployee?: (...params: any[]) => void) => void;
    /** 被选中时调用，参数为选中项的 value (或 key) 值 */
    onSelect?: (value: any, options?: OptionItemType | OptionItemType[], item?: Map<string, OptionItemType>) => void;
    /** 自定义选项内容 */
    optionRender?: (item: OptionItemType) => React.ReactNode;
    /** 搜索接口 */
    searchAction: Service<unknown, any[]>;
    /** 自定义搜索参数 */
    searchParams?: {};
    /** 自定义请求数据处理函数 */
    searchParamsHandle?: (data: any) => OptionItemType[];
}
