function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useRef, useState, createContext, useEffect, useMemo } from 'react';
import { useLocalStorageState } from 'ahooks';
import classnames from 'classnames';
import { Popover, Form } from 'rlj-design';
import SortBtn from "./SortBtn";
import SortContent from "./SortContent";
import { PREFIX_CLS } from "../constants/dictionary";
import "./style/index.less";
var prefixCls = "".concat(PREFIX_CLS, "-sort");
export var SortContext = /*#__PURE__*/createContext(null);

var Sort = function Sort(props) {
  var overlayClassName = props.overlayClassName,
      trigger = props.trigger,
      btnText = props.btnText,
      btnRender = props.btnRender,
      sortTitle = props.sortTitle,
      sortSecondTitle = props.sortSecondTitle,
      style = props.style,
      realSortOk = props.ok,
      items = props.items,
      _props$cacheKey = props.cacheKey,
      cacheKey = _props$cacheKey === void 0 ? 'sort' : _props$cacheKey,
      defaultFields = props.defaultFields,
      _props$showAutoSortBu = props.showAutoSortButton,
      showAutoSortButton = _props$showAutoSortBu === void 0 ? true : _props$showAutoSortBu,
      _props$isAutoSort = props.isAutoSort,
      isAutoSort = _props$isAutoSort === void 0 ? false : _props$isAutoSort;

  var _Form$useForm = Form.useForm(),
      _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
      form = _Form$useForm2[0];

  var validateFields = form.validateFields;

  var _useLocalStorageState = useLocalStorageState(cacheKey),
      _useLocalStorageState2 = _slicedToArray(_useLocalStorageState, 2),
      fields = _useLocalStorageState2[0],
      setFields = _useLocalStorageState2[1];

  var sortRef = useRef(null);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      open = _useState2[0],
      setOpen = _useState2[1];

  var _useState3 = useState(new Map([])),
      _useState4 = _slicedToArray(_useState3, 1),
      itemsMap = _useState4[0];

  var _useState5 = useState(new Map([])),
      _useState6 = _slicedToArray(_useState5, 1),
      addressMap = _useState6[0];

  var hasData = useMemo(function () {
    var _fields$filter;

    return !!(fields !== null && fields !== void 0 && (_fields$filter = fields.filter(function (item) {
      return item === null || item === void 0 ? void 0 : item.sortOrder;
    })) !== null && _fields$filter !== void 0 && _fields$filter.length);
  }, [fields]);
  useEffect(function () {
    if (!items || !(items !== null && items !== void 0 && items.length)) return;
    items === null || items === void 0 ? void 0 : items.forEach(function (_ref) {
      var fieldId = _ref.fieldId,
          sortStrategy = _ref.sortStrategy;
      (sortStrategy === null || sortStrategy === void 0 ? void 0 : sortStrategy.length) && itemsMap.set(fieldId, {
        fieldId: fieldId,
        sortStrategy: sortStrategy
      });
    }); // 过滤一下fields，防止已停用字段不在表头中导致展示错误

    var newFields = fields === null || fields === void 0 ? void 0 : fields.filter(function (_ref2) {
      var fieldId = _ref2.fieldId;
      return itemsMap.has(fieldId);
    });
    setFields(newFields);
  }, [items]);
  useEffect(function () {
    if (!defaultFields) return;
    setFields(defaultFields);
  }, [defaultFields]);

  var onFinish = function onFinish() {
    var _fields$;

    if ((fields === null || fields === void 0 ? void 0 : fields.length) === 1 && !((_fields$ = fields[0]) !== null && _fields$ !== void 0 && _fields$.sortOrder)) {
      realSortOk && realSortOk([]);
    } else {
      validateFields().then(function () {
        ok();
      }).catch(function (err) {
        console.error(err);
      });
    }
  };

  var ok = function ok() {
    realSortOk && realSortOk(fields);
  };

  return /*#__PURE__*/React.createElement(SortContext.Provider, {
    value: _objectSpread(_objectSpread({}, props), {}, {
      fields: fields,
      setFields: setFields,
      itemsMap: itemsMap,
      ok: ok,
      addressMap: addressMap,
      hasData: hasData,
      setOpen: setOpen,
      onFinish: onFinish
    })
  }, /*#__PURE__*/React.createElement(Form, {
    form: form,
    name: "sort-content",
    autoComplete: "off"
  }, /*#__PURE__*/React.createElement("div", {
    className: prefixCls,
    ref: sortRef
  }, /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(SortContent, {
      sortTitle: sortTitle,
      sortSecondTitle: sortSecondTitle,
      showAutoSortButton: showAutoSortButton,
      isAutoSort: isAutoSort
    }),
    placement: "bottomLeft",
    trigger: trigger,
    overlayClassName: classnames("".concat(prefixCls, "-popover"), overlayClassName),
    getPopupContainer: function getPopupContainer() {
      return sortRef.current;
    },
    open: open,
    onOpenChange: function onOpenChange(open) {
      return setOpen(open);
    }
  }, btnRender ? btnRender : /*#__PURE__*/React.createElement(SortBtn, {
    open: open,
    setOpen: setOpen,
    style: style
  }, btnText)))));
};

Sort.defaultProps = {
  cacheKey: 'sort',
  trigger: 'click',
  btnText: '排序',
  showAutoSortButton: true,
  isAutoSort: false
};
export default Sort;