function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useContext, useMemo, useEffect } from 'react';
import { Form, Select, Icon, Empty } from 'rlj-design';
import { PREFIX_CLS } from "../constants/dictionary";
import { SortContext } from "./Sort";
import "./style/sortValue.less";
var prefixCls = "".concat(PREFIX_CLS, "-sort-value");
export var deleteItem;

var SortValue = function SortValue(_ref) {
  var remove = _ref.remove,
      item = _ref.item;

  var _Form$useFormInstance = Form.useFormInstance(),
      setFieldValue = _Form$useFormInstance.setFieldValue,
      getFieldsValue = _Form$useFormInstance.getFieldsValue,
      getFieldValue = _Form$useFormInstance.getFieldValue,
      setFieldsValue = _Form$useFormInstance.setFieldsValue;

  var name = item.name;

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      currentSelected = _useState2[0],
      setCurrentSelected = _useState2[1];

  var _ref2 = useContext(SortContext) || {},
      _ref2$fields = _ref2.fields,
      fields = _ref2$fields === void 0 ? [] : _ref2$fields,
      setFields = _ref2.setFields,
      items = _ref2.items,
      itemsMap = _ref2.itemsMap;

  var options = useMemo(function () {
    (fields === null || fields === void 0 ? void 0 : fields.length) && setCurrentSelected(fields === null || fields === void 0 ? void 0 : fields[name]);
    return (items || []).filter(function (item) {
      var _item$sortStrategy;

      return item === null || item === void 0 ? void 0 : (_item$sortStrategy = item.sortStrategy) === null || _item$sortStrategy === void 0 ? void 0 : _item$sortStrategy.length;
    }).map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        showOption: !(fields !== null && fields !== void 0 && fields.map(function (obj) {
          return obj === null || obj === void 0 ? void 0 : obj.fieldId;
        }).includes(item === null || item === void 0 ? void 0 : item.fieldId))
      });
    });
  }, [items, fields]);
  var curOptions = useMemo(function () {
    var _itemsMap$get;

    if (!currentSelected) return;
    return (itemsMap === null || itemsMap === void 0 ? void 0 : (_itemsMap$get = itemsMap.get(currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldId)) === null || _itemsMap$get === void 0 ? void 0 : _itemsMap$get.sortStrategy) || [];
  }, [currentSelected]);
  useEffect(function () {
    if (items) {
      var _items$filter;

      var fieldId = getFieldValue(['fields', name, 'fieldId']);
      var curItem = (_items$filter = items.filter(function (item) {
        return item.fieldId === fieldId;
      })) === null || _items$filter === void 0 ? void 0 : _items$filter[0];
      setCurrentSelected(curItem);
    }
  }, [name]);

  var onChange = function onChange(e, options) {
    var _itemsMap$get2, _itemsMap$get2$sortSt, _itemsMap$get2$sortSt2, _getFieldsValue, _getFieldsValue$field;

    var _options$item = options.item,
        item = _options$item === void 0 ? {} : _options$item;
    var selected = fields === null || fields === void 0 ? void 0 : fields.map(function (item) {
      return item === null || item === void 0 ? void 0 : item.fieldId;
    });

    var _ref3 = currentSelected || {},
        fieldId = _ref3.fieldId;

    var index = fieldId ? selected.indexOf(fieldId) : -1;

    if (index >= 0) {
      selected.splice(index, 1);
    }

    selected.push(e);
    setCurrentSelected(item);
    setFieldValue(['fields', name, 'sortOrder'], itemsMap === null || itemsMap === void 0 ? void 0 : (_itemsMap$get2 = itemsMap.get(item === null || item === void 0 ? void 0 : item.fieldId)) === null || _itemsMap$get2 === void 0 ? void 0 : (_itemsMap$get2$sortSt = _itemsMap$get2.sortStrategy) === null || _itemsMap$get2$sortSt === void 0 ? void 0 : (_itemsMap$get2$sortSt2 = _itemsMap$get2$sortSt[0]) === null || _itemsMap$get2$sortSt2 === void 0 ? void 0 : _itemsMap$get2$sortSt2.value);
    setFields((_getFieldsValue = getFieldsValue()) === null || _getFieldsValue === void 0 ? void 0 : (_getFieldsValue$field = _getFieldsValue.fields) === null || _getFieldsValue$field === void 0 ? void 0 : _getFieldsValue$field.filter(function (item) {
      return item === null || item === void 0 ? void 0 : item.sortOrder;
    }));
  };

  deleteItem = function deleteItem(name) {
    var _getFieldsValue2, _getFieldsValue2$fiel;

    // 判断当前只剩下一条的时候，只清空输入框内数据
    if (((_getFieldsValue2 = getFieldsValue()) === null || _getFieldsValue2 === void 0 ? void 0 : (_getFieldsValue2$fiel = _getFieldsValue2.fields) === null || _getFieldsValue2$fiel === void 0 ? void 0 : _getFieldsValue2$fiel.length) === 1) {
      var _getFieldsValue3;

      setFieldsValue({
        fields: [undefined]
      });
      setCurrentSelected(undefined);
      setFields((_getFieldsValue3 = getFieldsValue()) === null || _getFieldsValue3 === void 0 ? void 0 : _getFieldsValue3.fields);
      return;
    }

    remove(name);
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-item")
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "draggable",
    size: 16,
    color: "#7f7f85",
    style: {
      marginTop: 8
    }
  }), /*#__PURE__*/React.createElement(Form.Item, {
    name: [name, 'fieldId'],
    style: {
      width: 160,
      margin: '0 8px'
    },
    rules: [{
      required: true,
      message: '不能为空'
    }]
  }, /*#__PURE__*/React.createElement(Select, {
    onChange: onChange,
    placeholder: "\u8BF7\u9009\u62E9",
    allowClear: false,
    optionFilterProp: "children",
    showSearch: true,
    notFoundContent: /*#__PURE__*/React.createElement(Empty, {
      description: "\u641C\u7D22\u65E0\u7ED3\u679C",
      image: Empty.PRESENTED_IMAGE_SIMPLE
    }),
    filterOption: function filterOption(input, option) {
      var _children, _children$toLowerCase;

      return (_children = option.children) === null || _children === void 0 ? void 0 : (_children$toLowerCase = _children.toLowerCase()) === null || _children$toLowerCase === void 0 ? void 0 : _children$toLowerCase.includes(input.toLowerCase());
    }
  }, options.map(function (item) {
    return (item.showOption || item.fieldId === (currentSelected === null || currentSelected === void 0 ? void 0 : currentSelected.fieldId)) && /*#__PURE__*/React.createElement(Select.Option, {
      key: item.fieldId,
      value: item.fieldId,
      item: item
    }, item.fieldName);
  }))), /*#__PURE__*/React.createElement(Form.Item, {
    name: [name, 'sortOrder'],
    style: {
      width: 192
    },
    rules: [{
      required: !!currentSelected,
      message: '不能为空'
    }]
  }, /*#__PURE__*/React.createElement(Select, {
    disabled: !(currentSelected !== null && currentSelected !== void 0 && currentSelected.fieldId),
    onChange: function onChange() {
      var _getFieldsValue4;

      return setFields((_getFieldsValue4 = getFieldsValue()) === null || _getFieldsValue4 === void 0 ? void 0 : _getFieldsValue4.fields);
    },
    options: curOptions,
    allowClear: false
  })), /*#__PURE__*/React.createElement("div", {
    className: "".concat(prefixCls, "-delete")
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "delete",
    size: 16,
    onClick: function onClick() {
      return deleteItem(name);
    }
  })));
};

export default SortValue;