import React, { useContext } from 'react';
import { getRowKeys } from "../../utils/tools";
import Item from "../item";
import { ExcelContext } from "../../index";
import "./index.less";

// 网格，表格中没有fixed的内容
var GridColumn = function GridColumn(props) {
  var rowIndex = props.rowIndex,
      style = props.style,
      columnIndex = props.columnIndex;
  var excelCtx = useContext(ExcelContext);
  var currentData = excelCtx.dataSource[rowIndex];
  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, currentData.mergeArr ? currentData.mergeArr.map(function (v, index) {
    return /*#__PURE__*/React.createElement(RenderItem, {
      key: index,
      currentData: v,
      rowIndex: rowIndex,
      subRowIndex: index,
      columnIndex: columnIndex,
      isMergeRow: true,
      mergeData: currentData
    });
  }) : /*#__PURE__*/React.createElement(RenderItem, {
    currentData: currentData,
    rowIndex: rowIndex,
    subRowIndex: 0,
    columnIndex: columnIndex
  }));
};

var RenderItem = function RenderItem(props) {
  var columnIndex = props.columnIndex,
      rowIndex = props.rowIndex,
      currentData = props.currentData,
      subRowIndex = props.subRowIndex,
      isMergeRow = props.isMergeRow,
      mergeData = props.mergeData;
  var excelCtx = useContext(ExcelContext);
  var _excelCtx$rowKey = excelCtx.rowKey,
      rowKey = _excelCtx$rowKey === void 0 ? 'id' : _excelCtx$rowKey,
      columnInfo = excelCtx.columnInfo;
  var currentColumn = columnInfo.noFixed.data[columnIndex];
  return /*#__PURE__*/React.createElement(Item, {
    key: getRowKeys(rowKey, currentData),
    isMergeRow: isMergeRow,
    rowIndex: rowIndex,
    subRowIndex: subRowIndex,
    columnIndex: columnIndex,
    currentData: currentData,
    currentColumn: currentColumn,
    mergeData: mergeData
  });
};

export default GridColumn;