function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useContext } from 'react';
import classnames from 'classnames';
import { Resizable } from 'react-resizable';
import { foldWidth, sorterWidth, extraIconWidth } from "../../utils/config";
import { getPrimary, getMinWidth, createCellPos, getKey } from "../../utils/tools";
import { doubleRight, doubleLeft, caretDown, caretUp, moreIcon } from "../../utils/icon";
import Ellipsis from "../../components/Ellipsis";
import Checked, { TYPE as CheckType } from "../../Checked";
import "./item.less";
import { ExcelContext } from "../../index";
var touchStartLeft = -1;
export default (function (props) {
  var _ref = useContext(ExcelContext),
      _ref$rowKey = _ref.rowKey,
      rowKey = _ref$rowKey === void 0 ? 'id' : _ref$rowKey,
      rowSelection = _ref.rowSelection,
      dataSource = _ref.dataSource,
      moveLine = _ref.moveLine,
      excelBox = _ref.excelBox,
      salaryBox = _ref.salaryBox,
      editableConfig = _ref.editableConfig,
      selectOneRow = _ref.selectOneRow,
      changeColumns = _ref.changeColumns,
      colData = _ref.colData,
      columnInfo = _ref.columnInfo;

  var index = props.index,
      style = props.style,
      mainColumns = props.mainColumns,
      isFixCol = props.isFixCol,
      isMerge = props.isMerge;
  var subColumns = mainColumns.children,
      resize = mainColumns.resize;
  var isNotShowSub = !subColumns || !subColumns.length; //短路，当children不存在的时候，不会执行后半部分，不用判断children是否是数组

  var _ref2 = editableConfig || {},
      editable = _ref2.editable,
      showColExtraHeader = _ref2.showColExtraHeader; // 默认的高度样式


  var defaultStyle = {
    height: colData.defaultItemHeight
  };
  var defaultRowSpanStyle = {
    height: colData.defaultItemHeight * 2
  };
  /**
   * 修改表头的状态, 折叠和排序
   */

  var changeColumn = function changeColumn(childIndex, value, type) {
    return function (e) {
      e.stopPropagation();
      changeColumns(index, childIndex, value, type);
    };
  };
  /**
   * 标图图标，排序图标和折叠图标，svg
   * @param item
   */


  var renderIcon = function renderIcon(item) {
    var sorter = item.sorter,
        sortOrder = item.sortOrder,
        fold = item.fold,
        iconConfig = item.iconConfig;
    return /*#__PURE__*/React.createElement("div", {
      className: "iconSpBox"
    }, iconConfig && /*#__PURE__*/React.createElement("div", {
      className: "iconExtraClass",
      style: {
        width: iconConfig.width || extraIconWidth
      }
    }, iconConfig.content ? iconConfig.content(item) : /*#__PURE__*/React.createElement("span", {
      style: {
        cursor: 'pointer',
        fontSize: iconConfig.fontSize || 14,
        color: iconConfig.color || '#c8c8cb'
      },
      onClick: iconConfig.onClick ? function () {
        return iconConfig.onClick(item);
      } : function () {}
    }, iconConfig.icon || moreIcon)), sorter && /*#__PURE__*/React.createElement("div", {
      className: "iconCaret"
    }, /*#__PURE__*/React.createElement("div", {
      className: getPrimary('iconCaret', sortOrder === 'ascend')
    }, caretUp), /*#__PURE__*/React.createElement("div", {
      className: getPrimary('iconCaret', sortOrder === 'descend')
    }, caretDown)), fold !== undefined && /*#__PURE__*/React.createElement("div", {
      className: getPrimary('iconFold'),
      onClick: changeColumn('main', !fold, 'fold')
    }, fold ? doubleRight : doubleLeft));
  };
  /**
   * 获取新的排序方式，在三种排序方式（默认、正序、倒叙）中切换
   * @param sortOrder
   */


  var getSortOrder = function getSortOrder(sortOrder) {
    var sortValue = undefined;

    if (!sortOrder) {
      sortValue = 'ascend';
    } else if (sortOrder === 'ascend') {
      sortValue = 'descend';
    }

    return sortValue;
  };
  /**
   * 超长省略内容
   * @param text   文本内容
   * @param width  宽度
   * @param paddingLeft  左内边距
   * @param paddingRight  右内边距
   * @param className  类名
   */


  var renderContent = function renderContent(text, width, paddingLeft, paddingRight, className) {
    if (text === 'rowSelectionChecked') {
      return /*#__PURE__*/React.createElement(Checked, {
        rowKey: rowKey,
        type: CheckType.header,
        rowSelection: rowSelection,
        dataSource: dataSource
      });
    }

    var style = {};
    if (paddingLeft) style.paddingLeft = paddingLeft;
    if (paddingLeft) style.paddingRight = paddingRight;

    if (typeof text === 'function') {
      return text(width);
    }

    return /*#__PURE__*/React.createElement("div", {
      style: style,
      className: className
    }, /*#__PURE__*/React.createElement(Ellipsis, {
      text: text,
      width: width,
      isMaxWidth: false
    }));
  };

  var handleSorter = function handleSorter(props) {
    return function (e) {
      var sorter = props.sorter,
          sortOrder = props.sortOrder,
          changeIndex = props.changeIndex;
      if (!sorter) return;
      changeColumn(changeIndex, getSortOrder(sortOrder), 'sort')(e);
    };
  }; // =============================================== 父项和子项 ===============================================

  /**
   * 父项-第一行
   */


  var renderMain = function renderMain(param) {
    var mainTitle = param.title,
        sorter = param.sorter,
        fold = param.fold,
        sortOrder = param.sortOrder,
        _param$paddingLeft = param.paddingLeft,
        paddingLeft = _param$paddingLeft === void 0 ? 0 : _param$paddingLeft,
        _param$paddingRight = param.paddingRight,
        paddingRight = _param$paddingRight === void 0 ? 0 : _param$paddingRight,
        valueType = param.valueType,
        iconConfig = param.iconConfig,
        dataIndex = param.dataIndex,
        children = param.children;
    var isResizeCol = isFixCol || resize === false; //是否可拖拽, 固定列和明确表示不能缩放的列

    var fatherAssist = paddingLeft + paddingRight; //额外的宽度

    var item = function item(type) {
      var ctxWidth = style.width - 20;
      var className = '';

      if (fold !== undefined) {
        ctxWidth -= foldWidth;
      }

      if (sorter) {
        ctxWidth -= sorterWidth;
      }

      if (fatherAssist) {
        ctxWidth -= fatherAssist;
      }

      if (iconConfig) {
        ctxWidth -= iconConfig.width || extraIconWidth;
      }

      if (!sorter && fold === undefined && ['int', 'number'].includes(valueType) && (true || !editable)) {
        className += ' int-value-style';
      }

      var rowSpan = isMerge && isNotShowSub;
      return /*#__PURE__*/React.createElement("div", {
        className: classnames('fatherBox', {
          rowSpan: rowSpan,
          top: type === 'top',
          sort: sorter,
          lastColHiddenBorder: param.lastCol,
          salaryExcelHeaderHighlight: selectOneRow && selectOneRow.dataIndex === dataIndex && (!children || !children.length)
        }),
        onClick: handleSorter({
          sorter: sorter,
          sortOrder: sortOrder,
          changeIndex: 'main'
        }),
        style: rowSpan ? defaultRowSpanStyle : defaultStyle
      }, renderContent(mainTitle, ctxWidth, paddingLeft, paddingRight, className), renderIcon(param));
    };

    if (isNotShowSub && !isResizeCol) {
      return renderResize(item(), getKey(param), 'main', param);
    } else if (!isNotShowSub) {
      return item('top');
    } else {
      return item();
    }
  };
  /**
   * 子项-第二行
   */


  var renderSub = function renderSub() {
    var item = function item(_item, key, changeIndex) {
      var width = _item.width,
          title = _item.title,
          sorter = _item.sorter,
          sortOrder = _item.sortOrder,
          _item$paddingLeft = _item.paddingLeft,
          paddingLeft = _item$paddingLeft === void 0 ? 0 : _item$paddingLeft,
          _item$paddingRight = _item.paddingRight,
          paddingRight = _item$paddingRight === void 0 ? 0 : _item$paddingRight,
          valueType = _item.valueType,
          dataIndex = _item.dataIndex;
      var childrenAssist = paddingLeft + paddingRight;
      var ctxWidth = width - 20;
      var className = '';

      if (sorter) {
        ctxWidth -= sorterWidth;
      }

      if (childrenAssist) {
        ctxWidth -= childrenAssist;
      }

      if (!sorter && ['int', 'number'].includes(valueType) && (true || !editable)) {
        className += ' int-value-style';
      }

      return /*#__PURE__*/React.createElement("div", {
        className: classnames('children', {
          sort: sorter,
          lastColHiddenBorder: _item.lastCol,
          salaryExcelHeaderHighlight: selectOneRow && selectOneRow.dataIndex === dataIndex
        }),
        style: _objectSpread({
          width: width
        }, defaultStyle),
        key: key,
        onClick: handleSorter({
          sorter: sorter,
          sortOrder: sortOrder,
          changeIndex: changeIndex
        })
      }, renderContent(title, ctxWidth, paddingLeft, paddingRight, className), renderIcon(_item));
    };

    return /*#__PURE__*/React.createElement("div", {
      className: "childrenBox"
    }, subColumns.map(function (v, i) {
      var dataIndex = v.dataIndex,
          key = v.key,
          resize = v.resize;
      var childrenKey = dataIndex || key;
      var childrenNotResize = resize === false;
      return childrenNotResize ? item(v, childrenKey, i) : renderResize(item(v, childrenKey, i), childrenKey, i, v);
    }));
  }; // =============================================== 父子组合-二行-最终渲染 ===============================================


  var renderHeaderExcelRow = function renderHeaderExcelRow() {
    if (!editable || showColExtraHeader === false) return;
    return /*#__PURE__*/React.createElement("div", {
      className: classnames('fatherBoxFather', {
        fatherBoxFatherFirst: index === 0,
        lastColHiddenBorder: mainColumns.lastCol
      }),
      style: defaultStyle
    }, createCellPos(index - 1));
  };

  var concatMainSub = function concatMainSub() {
    return /*#__PURE__*/React.createElement("div", {
      className: classnames('salaryExcelColumnsItem', {
        showStatus: !editable
      })
    }, renderHeaderExcelRow(), renderMain(mainColumns), !isNotShowSub && renderSub());
  }; // =============================================== 可拖拽item ===============================================


  var renderResize = function renderResize(children, id, type, item) {
    return /*#__PURE__*/React.createElement(Resizable, {
      key: id,
      width: style.width + 1,
      height: 0 //设置一个0，高度不重要，高度不会变, 未来需求可能需要变化
      ,
      onResize: handleResize(type, item),
      onResizeStart: handleResizeStart(type),
      onResizeStop: handleResizeStop(type, item),
      draggableOpts: {
        enableUserSelectHack: false
      }
    }, /*#__PURE__*/React.createElement("div", null, children));
  };

  var setMoveLine = function setMoveLine(pageX) {
    if (salaryBox.current && moveLine.current) {
      var _salaryBox$current$ge = salaryBox.current.getBoundingClientRect(),
          height = _salaryBox$current$ge.height,
          top = _salaryBox$current$ge.top;

      moveLine.current.style.top = "".concat(top + 1, "px");
      moveLine.current.style.height = "".concat(height, "px");
      moveLine.current.style.left = pageX + 'px';
      moveLine.current.style.display = 'block';
    }
  };

  var getSourceWidth = function getSourceWidth(changeIndex) {
    var sourceWidth;

    if (changeIndex === 'main') {
      sourceWidth = mainColumns.width;
    } else {
      sourceWidth = subColumns[changeIndex].width;
    }

    return sourceWidth;
  };

  var handleResize = function handleResize(changeIndex, item) {
    return function (e) {
      if (moveLine.current) {
        var sourceWidth = getSourceWidth(changeIndex); // 限制拖拽的最小宽度，并且不能在拖拽后表头的总宽度小于表格的最大宽度，
        // data的curMaxWidth是根据纵向是否有滚动条，计算好的值

        if (e.pageX - touchStartLeft + sourceWidth >= getMinWidth(item) && columnInfo.lenRus + e.pageX - touchStartLeft >= columnInfo.curMaxWidth) {
          setMoveLine(e.pageX);
        }
      }
    };
  };

  var handleResizeStart = function handleResizeStart() {
    return function (e) {
      touchStartLeft = e.pageX;
      window.tExcelResize = true; //阻止超长省略组件hover触发

      if (excelBox.current) {
        excelBox.current.style.userSelect = 'none';
        setMoveLine(e.pageX);
      }
    };
  };

  var handleResizeStop = function handleResizeStop(changeIndex, item) {
    return function (e) {
      window.tExcelResize = false; //允许超长省略组件hover触发

      var sourceWidth = getSourceWidth(changeIndex);
      var widthPre = Math.floor(e.pageX - touchStartLeft + sourceWidth);
      var minWidth = getMinWidth(item); // 拖拽后的表头总宽度比表格的宽度小

      if (columnInfo.lenRus + e.pageX - touchStartLeft <= columnInfo.curMaxWidth) {
        var tmp = sourceWidth - (columnInfo.lenRus - columnInfo.curMaxWidth);
        minWidth = tmp > minWidth ? tmp : minWidth;
      }

      var width = widthPre < minWidth ? minWidth : widthPre;

      if (width !== sourceWidth) {
        changeColumns(index, changeIndex, width, 'width');
      }

      touchStartLeft = -1;

      if (moveLine.current) {
        moveLine.current.style.display = 'none';
      }

      if (excelBox.current) {
        excelBox.current.style.userSelect = 'text';
      }
    };
  }; // =============================================== render ===============================================


  return /*#__PURE__*/React.createElement("div", {
    style: style
  }, concatMainSub());
});